// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from stubborn_buddies_msgs:msg/Status.idl
// generated code does not contain a copyright notice
#include "stubborn_buddies_msgs/msg/detail/status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
stubborn_buddies_msgs__msg__Status__init(stubborn_buddies_msgs__msg__Status * msg)
{
  if (!msg) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    stubborn_buddies_msgs__msg__Status__fini(msg);
    return false;
  }
  // missed_number
  msg->missed_number = 0;
  return true;
}

void
stubborn_buddies_msgs__msg__Status__fini(stubborn_buddies_msgs__msg__Status * msg)
{
  if (!msg) {
    return;
  }
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // missed_number
}

bool
stubborn_buddies_msgs__msg__Status__are_equal(const stubborn_buddies_msgs__msg__Status * lhs, const stubborn_buddies_msgs__msg__Status * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // missed_number
  if (lhs->missed_number != rhs->missed_number) {
    return false;
  }
  return true;
}

bool
stubborn_buddies_msgs__msg__Status__copy(
  const stubborn_buddies_msgs__msg__Status * input,
  stubborn_buddies_msgs__msg__Status * output)
{
  if (!input || !output) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // missed_number
  output->missed_number = input->missed_number;
  return true;
}

stubborn_buddies_msgs__msg__Status *
stubborn_buddies_msgs__msg__Status__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  stubborn_buddies_msgs__msg__Status * msg = (stubborn_buddies_msgs__msg__Status *)allocator.allocate(sizeof(stubborn_buddies_msgs__msg__Status), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(stubborn_buddies_msgs__msg__Status));
  bool success = stubborn_buddies_msgs__msg__Status__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
stubborn_buddies_msgs__msg__Status__destroy(stubborn_buddies_msgs__msg__Status * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    stubborn_buddies_msgs__msg__Status__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
stubborn_buddies_msgs__msg__Status__Sequence__init(stubborn_buddies_msgs__msg__Status__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  stubborn_buddies_msgs__msg__Status * data = NULL;

  if (size) {
    data = (stubborn_buddies_msgs__msg__Status *)allocator.zero_allocate(size, sizeof(stubborn_buddies_msgs__msg__Status), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = stubborn_buddies_msgs__msg__Status__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        stubborn_buddies_msgs__msg__Status__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
stubborn_buddies_msgs__msg__Status__Sequence__fini(stubborn_buddies_msgs__msg__Status__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      stubborn_buddies_msgs__msg__Status__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

stubborn_buddies_msgs__msg__Status__Sequence *
stubborn_buddies_msgs__msg__Status__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  stubborn_buddies_msgs__msg__Status__Sequence * array = (stubborn_buddies_msgs__msg__Status__Sequence *)allocator.allocate(sizeof(stubborn_buddies_msgs__msg__Status__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = stubborn_buddies_msgs__msg__Status__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
stubborn_buddies_msgs__msg__Status__Sequence__destroy(stubborn_buddies_msgs__msg__Status__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    stubborn_buddies_msgs__msg__Status__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
stubborn_buddies_msgs__msg__Status__Sequence__are_equal(const stubborn_buddies_msgs__msg__Status__Sequence * lhs, const stubborn_buddies_msgs__msg__Status__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!stubborn_buddies_msgs__msg__Status__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
stubborn_buddies_msgs__msg__Status__Sequence__copy(
  const stubborn_buddies_msgs__msg__Status__Sequence * input,
  stubborn_buddies_msgs__msg__Status__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(stubborn_buddies_msgs__msg__Status);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    stubborn_buddies_msgs__msg__Status * data =
      (stubborn_buddies_msgs__msg__Status *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!stubborn_buddies_msgs__msg__Status__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          stubborn_buddies_msgs__msg__Status__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!stubborn_buddies_msgs__msg__Status__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
